#pragma once

#include "TipModel.h"
#include "UpgraderView.h"
#include "Application.h"

#include <list>
#include <vector>

typedef std::basic_string<TCHAR> tstring;

struct AgreementUrlItem
{
	tstring url;
};

typedef std::vector<AgreementUrlItem> AgreementUrlList;


namespace tipupgrader
{


class UpgraderModel : public TipModel
{
public:
	UpgraderModel(void);
	virtual ~UpgraderModel(void);
	void Init();
	void Close();
#if 0
	UpgraderDocument* GetDocument() { return &m_Document; }
	void SetInstallControllerCallback(/*IInstallController* controller,*/ IInstallControllerCallback* callback)
	{
// 		if (m_InstallController)
// 			delete m_InstallController;
// 		m_InstallController = controller;

		if (m_InstallCallback)
			delete m_InstallCallback;
		m_InstallCallback = callback;
	}
	IInstallController* GetInstallController()
	{
		if (m_InstallController == NULL)
		{
			IInstallController* controller = CreateInstallController();
			if (!controller->Create())
			{
				delete controller;
				return NULL;
			}
			m_InstallController = controller;
		}
		return m_InstallController;
	}
//	IInstallController* GetInstallController() { return m_InstallController; }
	TipAppDataManager* GetAppDataManager() { return &m_AppDataManager; }

	tipbase::IPCCopyDataServer* GetIPCServer() { return &m_server; }
#endif

	void SetAgreementUrl(AgreementUrlList& urlList)
	{
		m_strAgreementUrl[0].clear();
		m_strAgreementUrl[1].clear();
		m_strAgreementUrl[2].clear();

		int nSize = urlList.size();
		for (int i = 0; i < nSize; i++)
		{
			m_strAgreementUrl[1] = urlList[i].url;
		}
	}
	tstring GetAgreementUrl(int index) 
	{
		return m_strAgreementUrl[index];
	}
	void OpenUrlWithDefaultBrowser(LPCTSTR url);

private:
	tstring m_strAgreementUrl[3];
//	UpgraderDocument m_Document;

// 	NotifyWindowManager *m_notifyWindowManager;
// 	TimerEventTriggerHandler *m_timerEventTriggerHandler;
// 	CheckCoreValue *m_checkCoreValue;

// 	IInstallController* m_InstallController;
// 	IInstallControllerCallback* m_InstallCallback;
// 	tipbase::IPCCopyDataServer m_server;
// 	ServerHooker* m_hooker;
// 	TipAppDataManager m_AppDataManager;
};




};